var opensearch = require("@opensearch-project/opensearch");
var elasticsearch = require('elasticsearch');
var _ = require('underscore');

function getClient(es_host, es_port, es_user, es_password, is_mcs2) {
    if(is_mcs2) {
      return new opensearch.Client({
        node: 'https://' + es_host + ':' + es_port,
        auth: {
            username: es_user,
            password: es_password
        }
      });
    } else {
      return new elasticsearch.Client({
        host: es_host + ':' + es_port,
        requestTimeout: 1000 * 60 * 60,
        keepAlive: false,
        log: 'warning'
      });
    }
}

function checkParams(
    es_host,
    es_port,
    es_user,
    es_password,
    is_mcs2,
    script_name,
    params_list) {
    if (is_mcs2) {
        if (_.isUndefined(es_host) || _.isUndefined(es_port) || _.isUndefined(es_user) || _.isUndefined(es_password)) {
        console.log("usage: node " +  script_name + " " + params_list);
        console.log("");
        process.exit();
      }
    } else {
        if (_.isUndefined(es_host) || _.isUndefined(es_port)) {
        console.log("usage: node " + script_name+ " " + params_list);
        console.log("");
        process.exit();
      }
    }
  }

  function getResponse(response, is_mcs2) {
    if (is_mcs2) {
      return response.body;
    } else {
      return response;
    }
}

module.exports = { getClient, checkParams, getResponse };

